


;*******************************************************************************************	
;- SUB page-size aus absoluter txtBOXpos(#)y + yCHARsize berechnen
;  & masken fr den bereich erstellen (verhindert bereichsber-
;  greifende zerstrung der daten)
;*******************************************************************************************

_CALCpageSIZ:
	clr	r16
	lds	r17,graphBOXposYte		;wird spter von anderer stelle geliefert !!!
	;nun die angesprochene 
	;first-page berechnen
	;-> txtBOXpos(#)y / 8 
_CALCpageLOOPa:
	cpi	r17,8
	brlo	_SETfirstPAGEmask		;nun erste page bestimmt	
	;txtBOXpos(#)y - 8
	;cntPAGE+1
	inc	r16				;page+1
	subi	r17,8
	jmp	_CALCpageLOOPa
	;
	;erste page maskieren
	_SETfirstPAGEmask:
		sts	firstPAGE,r16	;first-page(#)adresse sichern +++
		;
		;shift factor
		;fr datenplatzierung sichern
		;
		sts	SFTfactor,r17	;shift faktor 0-7
		clr	r16			;maske lschen


		_SETfirstMASKloop:
			tst	r17
			breq	_maskREADYa		;
			set				;set carry
			lsl	r16			;rotate left & carry to bit0 
			bld	r16,0

			dec	r17
			jmp	_SETfirstMASKloop

				_maskREADYa:
					sts	firstPAGEmask,r16	;first-page mask fertig +++


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	lds	r16,yCHARsiz
	dec	r16
	lds	r17,graphBOXposYte		;wird spter von anderer stelle geliefert !!!
	;nun die angesprochene 
	;last page-page berechnen
	;-> (txtBOXpos(#)y + yCHARsiz) / 8
	add	r17,r16
	clr	r16	
_CALCpageLOOPb:	
	cpi	r17,8
	brlo	_SETlastPAGEmask		;nun letzte page bestimmt	
	;txtBOXpos(#)y - 8
	;cntPAGE+1
	inc	r16				;page+1
	subi	r17,8
	jmp	_CALCpageLOOPb
	;
	;letzte page maskieren
	_SETlastPAGEmask:
		sts	lastPAGE,r16	;letzte-page(#) sichern +++
		clr	r16			;maske lschen
			

		inc	r17
		_SETlastMASKloop:
			tst	r17
			breq	_maskREADYb		;		
			set				;set carry
			lsl	r16			;rotate left & carry to bit0 
			bld	r16,0
			dec	r17
			jmp	_SETlastMASKloop

				_maskREADYb:		
					com	r16			;invertiere...
					sts	lastPAGEmask,r16	;last-page mask fertig +++

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
_CALCpageRANGE:
	lds	r16,firstPAGE	;(#) first page
	lds	r17,lastPAGE	;(#) last page
	sub	r17,r16
	;				;(#)pages ohne first page
	sts	effPAGErange,r17	;(#) effective page-range 0-7 
					;(...oder mehr - vom display abhngig)++++
	lds	r17,graphBOXposXte	;wird spter von anderer stelle geliefert !!!
	sts	xPOSabs,r17		;als absolute x-position speichern
	ret








;*********************************************************************************
;SUB mit aktuellen daten (0/1) gefllte spalte erzeugen und darstellen
;belegte reg= r10,r11,r13,r14,r15,(r16),r17,r19,(r20)
;a)DRWcolSUBfull == bereich mit aktuellen daten berschreiben
;b)DRWcolSUBplus == bereich mit aktuellen daten ergnzen
;*********************************************************************************
;first page vom display lesen
_DRWcolSUB:
;absolute x-position holen
;hier unbedingt die aktivierung der jeweiligen displayhlfte veranlassen !
;
;info: x-pos  >63 dann rechte displayseite cs1=1 / cs2=0
;      x-pos  >127 dann linke displayseite cs1=0 / cs2=1 & x-page +1
lds	r18,xPOSabs	;absolute x-position laden
cpi	r18,64
brlo	graphLEFTside
cpi	r18,displayCOLmax	;128 bei aktuellem display !
brsh	graphgoLEFTside
jmp	graphRIGHTside

;a)
graphLEFTside:
	ldi	r20,IleftYpage
	call	WRnewYpage		;y-spaltenadresse =x
	call	RDbusy
	rjmp	_DRWcolSUBgo


	;b)right side
	graphRIGHTside:
	;y-page=0 & rechte y-page
	ldi	r20,IrightYpage
	call	WRnewYpage		;y-spaltenadresse =x
	call	RDbusy
	rjmp	_DRWcolSUBgo


		;c)go left side (y-pages=0 & y-spaltenadresse =0 & x-pos=0)
		graphgoLEFTside:																				
		;
		;x-pos =0
		clr	r20
		sts	xPOSabs,r20											
		ldi	r20,IleftYpage
	
		call	WRnewYpage		;y-spaltenadresse =0
		call	RDbusy
		;TEST
;		jmp	_DRWcolSUBgo
		jmp	_DRWnoact		;x-displayende erreicht - ende!++++
		;


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;prfe ob bereich: 
;a) komplett mit neuen daten beschrieben 
;   ODER NUR
;b) mit neuen daten ergnzt wird
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
_DRWcolSUBgo:
	lds	r15,graphBOXflTE
	sbrc	r15,graphBOXfull	;0= ergnzen / 1= komplett
	rjmp	_DRWcolSUBfull	;1
	jmp	_DRWcolSUBplus	;0
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



_DRWcolSUBfull:
			;lade shift-register 0
			ldi	zh,high(SFTregST)
			ldi	zl,low(SFTregST)
			ld	r15,z+
			;prfe ob daten invertiert
			;werden sollen
			lds	r25,graphBOXflTE
			sbrc	r25,graphBOXinv	;0=normal / 1=invertiert		
			com	r15
			;	
			;lade effektiven page-bereich
			lds	r17,effPAGErange
			;lade first-page adresse
			lds	r11,firstPAGE	
			;lade xPOSabs
			lds	r19,xPOSabs
			;first-pagemaske
			lds	r14,firstPAGEmask
			call	_RDdisplayPAGE ;lese daten von glcd
			mov	r13,r10
			and	r10,r14	;empfangene daten maskieren
			tst	r17		;eff-page-range === nur eine page
			breq	_DRWonePAGE
			;
			com	r14
			and	r15,r14	;neue daten mit first page-mask maskieren
			jmp	_DRWmorePAGES		
			;nur eine page
		_DRWonePAGE:
			mov	r10,r13	;pagedaten wieder holen
			lds	r13,lastPAGEmask
			or	r14,r13	;masken ergnzen
			or	r14,r15	;mit daten ergnzen
			mov	r10,r14
			jmp	_DRWlastPAGEx



			;mehr pages
		_DRWmorePAGES:
			or	r10,r15	;restbereich mit daten ergnzen
			call	_WRdisplayPAGE ;schreieb daten nach glcd					
			;page +1
			inc	r11
			;shift register +1 (nchste page-daten)
			ld	r15,z+
			;prfe ob daten invertiert
			;werden sollen
			lds	r25,graphBOXflTE
			sbrc	r25,graphBOXinv	;0=normal / 1=invertiert		
			com	r15
			;full page mask
			clr	r10
			;eff page -1
			dec	r17	
			tst	r17
			brne	_DRWmorePAGES				
			jmp	_DRWlastPAGE	;bei 0= last page mask...


		_DRWlastPAGE:
			lds	r17,lastPAGEmask
			tst	r17
			breq	_DRWprepPAGE
			;
			call	_RDdisplayPAGE ;lese daten von glcd		
			and	r10,r17	;alte daten mit last page-mask maskieren
			com	r17
			and	r15,r17	;neue daten mit last page-mask maskieren
		
		_DRWprepPAGE:
			or	r10,r15	;mit daten ergnzen
		_DRWlastPAGEx:	
			call	_WRdisplayPAGE
		_DRWkorrXpos:
			;spalte fertig
			lds	r19,xPOSabs
			inc	r19
			sts	xPOSabs,r19
		_DRWnoact:
			ret



;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;hier auch rahmen lschen integrieren
;voraussetzung:graphBOXinv & graphBOXclr	gesetzt -ok
;masken im lschmodus bearbeiten (nicht invertieren(com))!
;

_DRWcolSUBplus:	
			;lade shift-register 0
			ldi	zh,high(SFTregST)
			ldi	zl,low(SFTregST)
			ld	r15,z+
			;prfe ob daten invertiert
			;werden sollen
			lds	r25,graphBOXflTE
			sbrc	r25,graphBOXinv	;0=normal / 1=invertiert		
			com	r15
			;lade effektiven page-bereich
			lds	r17,effPAGErange
			;lade first-page adresse
			lds	r11,firstPAGE	
			;lade xPOSabs
			lds	r19,xPOSabs
			
			
			;first-pagemaske
			lds	r14,firstPAGEmask
			call	_RDdisplayPAGE ;lese daten von glcd/daten in r10
				
			;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			;rahmen-lschmodus
			;pagemask nicht and -> or!
			;nicht inv !
			lds	r25,graphBOXflTE
			sbrs	r25,graphBOXclr	;0=normal / 1=rahmen lschen		
			rjmp	_DRWprepFpageOK
			or	r15,r14				
			rjmp	_DRWprepFpage
		_DRWprepFpageOK:
			com	r14			;mask inv	
			and	r15,r14	;neue daten maskieren
			;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		_DRWprepFpage:
			tst	r17		;eff-page-range === nur eine page
			breq	_DRWonePAGEx
			jmp	_DRWmorePAGESx		
			


			;nur eine page
		_DRWonePAGEx:
			;hier graphBOXclr prfen...
			lds	r25,graphBOXflTE
			lds	r13,lastPAGEmask
			;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			;rahmen-lschmodus
			;pagemask nicht and -> or!
			lds	r25,graphBOXflTE
			sbrs	r25,graphBOXclr	;0=normal / 1=rahmen lschen		
			rjmp	_DRWprepGpageOK
			or	r15,r13				
			rjmp	_DRWprepGpage
		_DRWprepGpageOK:
			com	r13			;mask inv
			and	r15,r13	;neue daten maskieren
			;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		_DRWprepGpage:
			;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			;rahmen lschen ? 
			sbrc	r25,graphBOXclr	;0=normal / 1=rahmen lschen		
			rjmp	_DRWonePAGEclear
			or	r10,r15		;daten in box ergnzen
			jmp	_DRWlastPAGExy
		_DRWonePAGEclear:
			and	r10,r15		;invertierten bereich datenbernahme
			jmp	_DRWlastPAGExy
			;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


			;mehr pages
		_DRWmorePAGESx:
			;hier graphBOXclr prfen...
			lds	r25,graphBOXflTE
			;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			;rahmen lschen ? 
			sbrc	r25,graphBOXclr	;0=normal / 1=rahmen lschen		
			rjmp	_DRWmorePAGESclear
			or	r10,r15		;restbereich mit daten ergnzen
			jmp	_DRWmorePAGESzz
		_DRWmorePAGESclear:
			and	r10,r15		;invertierten bereich datenbernahme
			;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		_DRWmorePAGESzz:
			call	_WRdisplayPAGE ;schreieb daten nach glcd					
			;page +1
			inc	r11
			;shift register +1 (nchste page-daten)
			ld	r15,z+
			;prfe ob daten invertiert
			;werden sollen
			lds	r25,graphBOXflTE
			sbrc	r25,graphBOXinv	;0=normal / 1=invertiert		
			com	r15
			;nur mit neuen Daten ergnzen
			call	_RDdisplayPAGE ;lese daten von glcd		
			;eff page -1
			dec	r17	
			tst	r17
			brne	_DRWmorePAGESx				
			jmp	_DRWlastPAGExz	;bei 0= last page mask...




		_DRWlastPAGExz:
			lds	r17,lastPAGEmask
			tst	r17
			breq	_DRWprepPAGEx
			;
			call	_RDdisplayPAGE ;lese daten von glcd		
			;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			;rahmen-lschmodus
			;pagemask nicht and -> or!
			lds	r25,graphBOXflTE
			sbrs	r25,graphBOXclr	;0=normal / 1=rahmen lschen		
			rjmp	_DRWprepHpageOK
			or	r15,r17				
			rjmp	_DRWprepPAGEx
		_DRWprepHpageOK:
			com	r17			;mask inv		
			and	r15,r17	;neue daten maskieren
			;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		_DRWprepPAGEx:
			;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			;hier graphBOXclr prfen...
			lds	r25,graphBOXflTE
			;rahmen lschen ? 
			sbrc	r25,graphBOXclr	;0=normal / 1=rahmen lschen		
			rjmp	_DRWlastPAGEclear
			or	r10,r15		;restbereich mit daten ergnzen
			jmp	_DRWlastPAGExy
		_DRWlastPAGEclear:
			and	r10,r15		;invertierten bereich datenbernahme
			;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		_DRWlastPAGExy:	
			call	_WRdisplayPAGE
		_DRWkorrXposx:
			;spalte fertig
			lds	r19,xPOSabs
			inc	r19
			sts	xPOSabs,r19
		_DRWnoactx:
			ret





;***************************************************************************************
;sub _plotXY --- darstellung einzelner punkte
;variablen: xPOSabs -> absolute x-koordinate 
;		yPOSabs -> absolute y-koordinate
;flags:	<graphBOXflTE>graphBOXinv (0=set point / 1= clear point)
;***************************************************************************************
_plotXY:
;absolute x-position holen
;hier unbedingt die aktivierung der jeweiligen displayhlfte veranlassen !
;
;info: x-pos  >63 dann rechte displayseite cs1=1 / cs2=0
;      x-pos  >127 dann linke displayseite cs1=0 / cs2=1 & x-page +1
lds	r18,xPOSabs	;absolute x-position laden
cpi	r18,64
brlo	plotLEFTside
cpi	r18,displayCOLmax	;128 bei aktuellem display !
brsh	NOplotside
jmp	plotRIGHTside

;a)
plotLEFTside:
	ldi	r20,IleftYpage
	call	WRnewYpage		;y-spaltenadresse =x
	call	RDbusy
	rjmp	_PLOTcolSUBgo


	;b)right side
	plotRIGHTside:
	;y-page=0 & rechte y-page
	ldi	r20,IrightYpage
	call	WRnewYpage		;y-spaltenadresse =x
	call	RDbusy
	rjmp	_PLOTcolSUBgo


		;c)no plot side
		NOplotside:																				
		jmp	_PLOTnoact		;x-displayende erreicht - ende!++++


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

_PLOTcolSUBgo:
	;page berechnen
	;r11 = page 
	;r10 = daten
	clr	r16
	lds	r17,yPOSabs		;
	;nun die angesprochene 
	;first-page berechnen
	;-> yPOSabs(#)y / 8 
_plotxyLOOPa:
	cpi	r17,8
	brlo	_SETpage		;nun page bestimmt	
	;yPOSabs(#)y - 8
	;cntPAGE+1
	inc	r16				;page+1
	subi	r17,8
	jmp	_plotxyLOOPa
	;
	;daten nach page integrieren
_SETpage:
	mov	r11,r16	;page in r11
	clr	r16			;maske lschen
	set				;set t-flag
	;
		_SETpageloopX:
			lsl	r16			
			bld	r16,0
			tst	r17
			breq	_SETpageLOOPREADYa		;
			clt				
			dec	r17
			jmp	_SETpageloopX	
			;	
_SETpageLOOPREADYa:	
	;hier:punkt setzen oder lschen 
	mov	r9,r16	;bitposition innnerhalb der page nach r9
	com	r16
	mov	r8,r16	;als mask verwenden !
	lds	r16,graphBOXflTE
	sbrs	r16,graphBOXinv
	rjmp	_PLOTpageGO
	com	r9	
_PLOTpageGO:
	;zuerst page-inhalt lesen
	call	_RDdisplayPAGE	;daten in r10
	;maskieren
	and	r10,r8	;rest belassen
	or	r10,r9	;ergnzen
	call	_WRdisplayPAGE	;daten senden
	;
 _PLOTnoact:
 	ret
	







;****************************************************************
;sub 64-bit shift register
;****************************************************************
	;bit *factor ins schieberegister
_SFTregA:
	lsl	r2	;
	bld	r2,0  ;t-flag nach bit<0> schieberegister
	clt		;clear t-flag
	brcc	_SFTregB
	set		;set t-flag
_SFTregB:
	lsl	r3
	bld	r3,0	;t-flag
	clt		;clear t-flag
	brcc	_SFTregC
	set		;set t-flag
_SFTregC:
	lsl	r4
	bld	r4,0	;t-flag
	clt		;clear t-flag
	brcc	_SFTregD
	set		;set t-flag
_SFTregD:
	lsl	r5
	bld	r5,0	;t-flag
	clt		;clear t-flag
	brcc	_SFTregE
	set		;set t-flag
_SFTregE:
	lsl	r6
	bld	r6,0	;t-flag
	clt		;clear t-flag
	brcc	_SFTregF
	set		;set t-flag
_SFTregF:
	lsl	r7
	bld	r7,0	;t-flag
	clt		;clear t-flag
	brcc	_SFTregG
	set		;set t-flag
_SFTregG:
	lsl	r8
	bld	r8,0	;t-flag
	clt		;clear t-flag
	brcc	_SFTregH
	set		;set t-flag
_SFTregH:
	lsl	r9
	bld	r9,0	;t-flag
	ret
