;****************************************************************
;cursorbox-steuerung
;****************************************************************
;a)nur bei vertikalen/horizontalen auswahlmens aktivierbar !
;b)<graphBOXcursor>=1 cursor aktiv | 0= deaktiv +++ info vom Gtxt-modul
;c)cursorsteuerung via drehratengeber...
;
_graphCURSOR:
    ;check for remote
    lds r17,REMif
    sbrs    r17,REMon
    rjmp    _graphCURSORgo           ;no remote
    ;slave?
    sbrc    r17,REMstate
    rjmp    _graphCURSORgo           ;no slave remote
    rjmp    _CURSORbk                ;slave <=> back without an action



_graphCURSORgo:
	;backlight
	call	_BlightA
	;cursor-box aktiv
	;-> indextabelle einlesen == auswhlbare textmarken
	;-> inhalt der cursorbox normal/invertieren ?
	;-> aktuellen cursorindex laden
	;
	;letzten drehratenwert & neuen drehratenwert (H/L-edge)
	;vergleichen..
	;<=> cursorposition beibehalten & push funktion (auswhlen) prfen
	;
	;-> kein cursor erwnscht & edit-mode disabled == up/dw wirkungslos!
	;-> kein cursor erwnscht & edit-mode enabled  == up/dw parameter manipulieren!
	;-> cursor aktiv
	;letzten drehratenstatus prfen

	lds	xl,curMODflTE
	sbrs xl,BOXcursor
	rjmp	_CHECKturnCTx
	sbrs	xl,curINIT	;cursor (falls enabled)schon initialisiert ???
	rjmp	_graphCURSORindex	;...zuerst initialisieren !!!
	rjmp	_CHECKturnCT
	;cursor deaktiv !
	;<=> keine text-auswahlmglichkeit
	;<=> keien parameterauswahl mglich (immer 1 parameter editierbar!)
_CHECKturnCTx:
	ldi	r17,0xff
	sts	curINDEX,r17
_CHECKturnCT:

   ;NEW*******************
    lds	r16,comFLAG
	sbrc	r16,newHIFdata		;1=neue HIF-daten im buffer
    rjmp    _TURNbk   
    sbrc    r16,waitHIFdata
    rjmp    _TURNbk          ;still waiting for system data, as a kind of acknowledge
   
    ;**********************
  

	;*****NEU********************************
	;rc5-push prfen & ausfhren
	lds		r17,rc5decFL
	sbrs	r17,compl		;aktuelle rc5 daten vorhanden?
	rjmp	_CHECKturnCTb	;nein !
	;aktuelle daten prfen...
	lds		r16,rc5data
	cpi		r16,0			;push-code =0
	brne	_CHECKturnCTb	;nein !
	;compl & data ok !
	cbr		r17,1<<compl
	sts		rc5decFL,r17
	;backlight flag setzen
	lds	r16,DIMflag
	sbr	r16,1<<BLnorm
	sts	DIMflag,r16
		;......................
	lds	xl,curMODflTE
	jmp	_DpushB
	;****************************************
	;	
_CHECKturnCTb:
	;zuerst push funktion prfen
	sbis	pinc,Dpush
	rjmp	_Dpush
	sbr	xl,1<<puHIGH	;status aktualisieren
	sts	curMODflTE,xl
	;drehratencounter prfen...
	lds	r17,TURNcnt	
	tst	r17
	breq	_CHECKturn
	dec	r17
	sts	TURNcnt,r17
	jmp	_CURSORbk
_CHECKturn:
	;*****NEU********************************
	;rc5-up prfen & ausfhren
	lds		r17,rc5decFL
	sbrs	r17,compl		;aktuelle rc5 daten vorhanden?
	rjmp	_CHECKturnCTbb	;nein !
	;aktuelle daten prfen...
	lds		r16,rc5data
	cpi		r16,2			;up-code =2
	brne	_CHECKturnCTW	;nein !
	;compl & data ok !
	cbr		r17,1<<compl
	sts		rc5decFL,r17
	;backlight flag setzen
	lds	r16,DIMflag
	sbr	r16,1<<BLnorm
	sts	DIMflag,r16
		;......................
	lds	xl,curMODflTE
	jmp	_DturnUPbx

	;*****NEU********************************
	;rc5-down prfen & ausfhren
_CHECKturnCTW:
	cpi		r16,1			;dw-code =1
	brne	_CHECKturnCTbb	;nein !
	;compl & data ok !
	cbr		r17,1<<compl
	sts		rc5decFL,r17
	;backlight flag setzen
	lds	r16,DIMflag
	sbr	r16,1<<BLnorm
	sts	DIMflag,r16
		;......................
	lds	xl,curMODflTE
	jmp	_DturnDWbx



_CHECKturnCTbb:
    ;********NEW**************
    ;check further rc5 data
    ;*************************
    ;rc5-up prfen & ausfhren
	lds		r17,rc5decFL
	sbrs	r17,compl		;aktuelle rc5 daten vorhanden?
	rjmp	_CHECKturnCTbbx	;nein !
    ;****************************
    ;call sub to decode rc5 data
    ;next time...
    ;data: rc5INSte
    ;flag: newINS
    ;****************************
    sbr     r17,1<<newINS
    cbr     r17,1<<compl
    sts     rc5decFL,r17
    sts     rc5INSte,r16     ;store rc5 data temporary

_CHECKturnCTbbx:
	;***************************************************
	;nur einbinden wenn kein panasonic encoder angeschlossen
	;jmp	_NOpanasonicENC
	;***************************************************
	lds	r16,countRIGHT
	tst	r16
	breq	_CHECKencoderLEFT
	;--------------------------
	;counterRIGHT-1
	dec	r16
	sts	countRIGHT,r16
	;backlight flag setzen
	lds	r16,DIMflag
	sbr	r16,1<<BLnorm
	sts	DIMflag,r16
	jmp	_DturnUPbx
	;--------------------------
_CHECKencoderLEFT:
	lds	r16,countLEFT
	tst	r16
	brne	_CHECKencoderLEFTdo
    ;.....................................
    ;NEW jmp directly back !!!
	jmp	   _TURNbk   ;_CURSORbk _graphCURSORindex                   ;why?????????
    ;.....................................


_CHECKencoderLEFTdo:
	;counterLEFT-1
	dec	r16
	sts	countLEFT,r16
	;backlight flag setzen
	lds	r16,DIMflag
	sbr	r16,1<<BLnorm
	sts	DIMflag,r16
	jmp	_DturnDWbx
	;***************************************************



_NOpanasonicENC:
	sbis	pinc,Dup
	rjmp	_DturnUP
	sbr	xl,1<<sigBBK	;status aktualisieren
	sts	curMODflTE,xl
	;
	sbis	pinc,Ddw
	rjmp	_DturnDW
	sbr	xl,1<<sigABK	;status aktualisieren
	sts	curMODflTE,xl
	jmp	_graphCURSORindex

	;up
	;& alte cursorbox lschen
	;& curINDEX +1
	;jedoch nicht grer maxINDEX
_DturnUP:
	lds	xl,curMODflTE
	;zuerst prfen ob's ne h/l flanke war
	sbrs	xl,sigBBK
	rjmp	_turnBK
		;
		;sigBBK flag clr
		cbr	xl,1<<sigBBK
		sts	curMODflTE,xl
		;backlight flag setzen
		lds	r16,DIMflag
		sbr	r16,1<<BLnorm
		sts	DIMflag,r16
		;......................

_DturnUPbx:
		;
	sbrc	xl,curEDIT
	rjmp	_DturnUPpara	;+++edit-parameter mode aktiv
	;- keine parameter manipulation
	;- cursormode?
	sbrs	xl,BOXcursor
	rjmp	_DturnUPc		;+++kein cursor mode == turn up wirkungslos!
	;
	lds	xl,curBOXaktX			;aktuelle BOXposX holen
	sts	graphBOXposXte,xl	;x speichern
	sts	xPOSabs,xl
	;
	lds	xl,curBOXaktY
	sts	graphBOXposYte,xl	;y speichern
	sts	yPOSabs,xl
	;
	lds	xl,curSIZaktX
	sts	xCHARsiz,xl		;char x speichern
	;
	lds	xl,curSIZaktY
	sts	yCHARsiz,xl		;char y speichern
	;linienstrke cursorbox
	lds	xl,curLINEakt
	sts	LINEth,xl
	;graphische darstellung
	clr	xl
	sbr	xl,1<<graphBOXcont
	;sbr	xl,1<<graphBOXfull
	sbr	xl,1<<graphBOXclr ;zum lschen setzen !!!
	sbr	xl,1<<graphBOXinv ;zum lschen setzen !!!
	sts	graphBOXflTE,xl
	;nun cursorbox darstellen
	call	_DRWrectangle
	;
	;nun curINDEX+1
	lds	xl,curINDEX
	lds	xh,maxINDEX
	cp	xl,xh
	brsh	_DturnUPb
	inc	xl
_DturnUPb:
	sts	curINDEX,xl
_DturnUPc:
	;und neu berechnen/darstellen
	jmp	_TURNbk
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

_DturnUPpara:	;+++edit-parameter mode aktiv
	;hier noch min/max testen
	;hier noch paraMIN/paraMAX testen
	lds	xl,paraA
	lds	xh,paraMAX
	cp	xl,xh
	breq	_DturnUPparaNOT	;==
	brsh	_DturnUPparaKORR	;>MAX
	jmp	_DturnUPparaCT	;>MIN
_DturnUPparaKORR:
	mov	xl,xh			;==
	jmp	_DturnUPparaNOT
_DturnUPparaCT:
	inc	xl
_DturnUPparaNOT:
	sts	paraA,xl
	;korrigierten parameter senden
	jmp	_sndPARAspi





;----------------------------------------------------------------------------------------------
	;dw
	;& alte cursorbox lschen
	;& curINDEX -1
	;jedoch nicht kleiner 0
_DturnDW:
	lds	xl,curMODflTE
	;zuerst prfen ob's ne h/l flanke war
	sbrs	xl,sigABK
	rjmp	_turnBK
		;
		;sigABK flag clr
		cbr	xl,1<<sigABK
		sts	curMODflTE,xl
		;backlight flag setzen
		lds	r16,DIMflag
		sbr	r16,1<<BLnorm
		sts	DIMflag,r16
		;......................
		;
		;
_DturnDWbx:
	sbrc	xl,curEDIT
	rjmp	_DturnDWpara		;+++edit-parameter mode aktiv
	;- keine parameter manipulation
	;- cursormode?
	sbrs	xl,BOXcursor
	rjmp	_DturnDWb		;+++kein cursor mode == turn dw wirkungslos!

	;alte cursorbox lschen
	lds	xl,curBOXaktX		;aktuelle BOXposX holen
	sts	graphBOXposXte,xl		;x speichern
	sts	xPOSabs,xl
	;
	lds	xl,curBOXaktY
	sts	graphBOXposYte,xl	;y speichern
	sts	yPOSabs,xl
	;
	lds	xl,curSIZaktX
	sts	xCHARsiz,xl		;char x speichern
	;
	lds	xl,curSIZaktY
	sts	yCHARsiz,xl		;char y speichern
	;linienstrke cursorbox
	lds	xl,curLINEakt
	sts	LINEth,xl
	;graphische darstellung
	clr	xl
	sbr	xl,1<<graphBOXcont
	;sbr	xl,1<<graphBOXfull
	sbr	xl,1<<graphBOXclr ;zum lschen setzen !!!
	sbr	xl,1<<graphBOXinv ;zum lschen setzen !!!
	sts	graphBOXflTE,xl
	;nun cursorbox darstellen
	call	_DRWrectangle
	;
	;nun curINDEX-1
	lds	xl,curINDEX
	tst	xl
	breq	_DturnDWa
	dec	xl
_DturnDWa:
	sts	curINDEX,xl
_DturnDWb:
	;und neu berechnen/darstellen
	jmp	_TURNbk
	;
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;
_DturnDWpara:
	;hier noch paraMIN/paraMAX testen
	lds	xl,paraA
	tst	xl
	breq	_DturnDWparaNOT	;=0
	lds	xh,paraMIN
	cp	xl,xh
	breq	_DturnDWparaNOT	;==
	brlo	_DturnDWparaKORR	;<MIN
	jmp	_DturnDWparaCT	;>MIN
_DturnDWparaKORR:
	mov	xl,xh			;==
	jmp	_DturnDWparaNOT
_DturnDWparaCT:
	dec	xl
_DturnDWparaNOT:
	sts	paraA,xl
	jmp	_sndPARAspi




;------------------------------------------------------------------------------------------
	;push
	;->prfe ob im aktuellen index edit-parameter enthalten sind 
	;  * dann mittels up/down innerhalb min/max grenzen vernderbar
	;  & jede nderung an mastersystem bertragen ->neuer wert wird im
	;    mastersystem geprft und anschl. wieder an den slave verschickt
	;
	;->kein edit-parameter 
	;  * nur aktuellen index an mastersystem bertragen
	;
_Dpush:
	;backlight flag setzen
	lds	r16,DIMflag
	sbr	r16,1<<BLnorm
	sts	DIMflag,r16
		;......................
	lds	xl,curMODflTE
	;zuerst prfen ob's ne h/l flanke war
	sbrs	xl,puHIGH
	rjmp	_turnBK
	;
	;sigBBK flag clr
	cbr	xl,1<<puHIGH
	sts	curMODflTE,xl
	;
	;hier bei aktuellen rc5 daten einsteigen !
_DpushB:
	sbrc	xl,curEDIT
	rjmp	_DpushPARA		;+++edit-parameter mode schon aktiv
	;nun parameter function
	;prfen
	lds	xh,paraFUNC		;gepufferte eingangsdaten auf edit prfen
	sbrs	xh,ediG
	rjmp	_DpushLDpact	;aktuellen parameter (zum index passend) mitsenden
	;bereinstimmung editiert werden
	;steuerflag setzen
	lds	xl,curMODflTE
	sbr	xl,1<<curEDIT
	sts	curMODflTE,xl
	jmp	_DpushLDpact	;aktuellen parameter (zum index passend) mitsenden + edit mode !!!!

	;edit mode beenden
	;
_DpushPARA:
	;steuerflag lschen
	lds	xl,curMODflTE
	cbr	xl,1<<curEDIT
	sts	curMODflTE,xl
	;edit flag f. master lschen
	lds	xl,paraFUNC		; edit prfen lschen
	cbr	xl,1<<ediG
	sts	paraFUNC,xl
	;
	jmp	_sndPARAspi
	;
;*****************************************************************
;parametertabelle (paraACT):
;<index>,<paraFUNC>,<paraPOS>,<PARAx>,<paraMINx>,<paraMAXx>,.....
;*****************************************************************
	;parameter file auf bereinstimmung 
	;mit aktuellem index prfen
	;ja = parameter holen und zur bearbeitung
	;     an temp. variable bergeben
_DpushLDpact:
	;+++parameter file abklappern
	;nun parametertabelle ergnzen
	;-> mit cntPAR adressieren == (paraACT)+(cntPAR*6)
	ldi	zh,high(paraACT)
	ldi	zl,low(paraACT)
	lds	xl,curINDEX	;aktuell cursorindex
	ldi	yl,6
	clr	yh
_DpushLDpactLOOP:
	ld	xh,z
	cp	xh,xl
	breq	_DpushLDpactOK	;gefunden
	adiw	zh:zl,6
	add	yh,yl
	cpi	yh,90
	brsh	_DpushLDpactNOK	;out of range
	jmp	_DpushLDpactLOOP
	;passt..
_DpushLDpactOK:
	adiw	zh:zl,2
	ld	xl,z+	;parameter position
	sts	paraPOS,xl
	ld	xl,z+	;parameter laden
	sts	paraA,xl	;&sichern
	ld	xl,z+	;parameter minimalwert
	sts	paraMIN,xl	;sichern
	ld	xl,z	;parameter maximalwert
	sts	paraMAX,xl	;sichern
	;parameter via spi senden
	jmp	_sndPARAspi
	;
	;nur index via spi senden
_DpushLDpactNOK:
	jmp	_sndPARAspi






_TURNbk:
	ldi	r17,90	;test90/255
	sts	TURNcnt,r17
	jmp	_graphCURSORindex





;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;index an spi schicken
;format:<index>,<paraFUNC>,<paraPOS>,<PARAx>,<paraMINx>,<paraMAXx>
_sndPARAspi:
    ;NEW*******************
;    lds	r16,comFLAG
; 	 sbrc	r16,newHIFdata		;1=neue HIF-daten im buffer
;    rjmp    _CURSORbk   
;    sbrc    r16,waitHIFdata
;    rjmp    _TURNbk             ;still waiting for system data, as a kind of acknowledge
   
    ;**********************
  

	lds	r16,curINDEX
	sts	curINDEXte,r16
	;
	lds	r16,paraFUNC
	sts	paraFUNCte,r16
	;
	lds	r16,paraPOS
	sts	paraPOSte,r16
	;
	lds	r16,paraA
	sts	paraAte,r16
	;
	lds	r16,paraMIN
	sts	paraMINte,r16
	;
	lds	r16,paraMAX
	sts	paraMAXte,r16


	lds	r16,comFLAG
	sbr	r16,1<<newHIFtx
    sbr r16,1<<waitHIFdata  ;-> wait for concept-data... cleared after interpreting !
	sts	comFLAG,r16
	call	_conceptSND
	jmp		_TURNbk	;_graphCURSORindex





;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


	;>   cursorposition +1 & prfen ob wert in der tabelle enthalten ist
	;    ->wert innerhalb tabelle    = ok
	;    ->wert nicht mehr enthalten = a)prfe ob aktueller wert > maxINDEX
	;					       ...dann kein weiterer text vorhanden
	;					     b)wenn aktueller wert >=maxINDEX
	;						 ...dann Gtxt wg. darstellungskorrektur aufrufen
	;
	;<   cursorposition -1 & prfen ob wert in der tabelle enthalten ist
	;    ->wert innerhalb tabelle    = ok 
	;    ->wert nicht mehr enthalten = prfe ob aktueller wert =0
	;					     ...dann kein weiterer text vorhanden
	;					     ...Gtxt wg. darstellungskorrektur aufrufen
	;







_graphCURSORindex:
	;zuerst prfen ob cursor erlaubt (liefert sysIF)
	lds	 xl,curMODflTE
	sbrs xl,BOXcursor
	rjmp _CURSORbk

 
	;erlaubt !!!!
	;cursor activ...
	sbr	xl,1<<BOXactiv
	sts	curMODflTE,xl
	;
	lds	xl,CURindex		;aktuellen cursorindex laden
	lds	xh,upperINDEX	;obersten/linken sichtbaren index laden
	lds	r24,downINDEX	;untersten /rechten sichtbaren index laden
	;suche passenden index im sichtbaren bereich

_searchCURindex:
	cp	xl,xh
	brsh	_searchCURindexB	;cursor >= upper index (OK)
	rjmp	_NOequINDEX		;cursor <  upper index (bedeutet:liste neu aufbauen)
_searchCURindexB:
	cp	xl,r24
	breq	_EQUindex		;cursor  = down index (OK)
	brsh	_NOequINDEX		;cursor >= down index (bedeutet: liste neu aufbauen)
	rjmp	_EQUindex		;cursor <  down index (OK)






	;kein passender index in liste enthalten...
	;prfe ob curINDEX > dem grten enthaltenen index ist
	;    oder curINDEX < dem kleinsten enthaltenen index ist
	;....upper index korrigieren &  _sys02IF wegen neuer organisation aufrufen !
_NOequINDEX:
	lds	xl,CURindex
	lds	xh,maxINDEX		;grten, in der tabelle enthaltenen index laden
	inc	xh
	cp	xl,xh			
	brlo	_NOequINDEXrange
	dec	xh			;neuer wert zu gro...
	sts	CURindex,xh		;auf maxINDEX
	;es bleibt so wie es ist
	;_sys02IF wg. Reorganisation
	;aufrufen
	call	_sys02IF
	;jetzt nochmal das Ganze
	;auf plausibilitt prfen
	jmp	_graphCURSORindex
	;
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;
	;
	;zuerst prfen ob CURindex=0
_NOequINDEXrange:
	tst	xl
	breq	_NOequINDEXzero	;=0
	jmp	_NOequINDEXlower
_NOequINDEXzero:
	sts	upperINDEX,xl
	;_sys02IF wg. Reorganisation
	;aufrufen
	call	_sys02IF
	;jetzt nochmal das Ganze
	;auf plausibilitt prfen
	jmp	_graphCURSORindex
	;
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;
	;curINDEX<upperINDEX
_NOequINDEXlower:
	lds	r24,upperINDEX
	cp	xl,r24
	brlo	_NOequINDEXlow
	jmp	_NOequINDEXhigher
	;
_NOequINDEXlow:
	lds	xl,upperINDEX
	dec	xl
	sts	upperINDEX,xl
	;_sys02IF wg. Reorganisation
	;aufrufen
	call	_sys02IF
	;jetzt nochmal das Ganze
	;auf plausibilitt prfen
	jmp	_graphCURSORindex
	;
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;
	;curINDEX > downINDEX
_NOequINDEXhigher:
	lds	r24,downINDEX
	inc	r24
	cp	xl,r24
	brsh	_NOequINDEXhighB
	jmp	_EQUindex	;passt doch
	;
_NOequINDEXhighB:
	lds	xl,upperINDEX
	inc	xl
	sts	upperINDEX,xl
	;_sys02IF wg. Reorganisation
	;aufrufen
	call	_sys02IF
	;jetzt nochmal das Ganze
	;auf plausibilitt prfen
	jmp	_graphCURSORindex






	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;passenden index innerhalb des displayfeldes gefunden
	;& koordinaten aus buffer holen
	;& neue cursorposition bestimmen
	;& cursorbox darstellen
_EQUindex:
	;format:<index><BOXposX><BOXposY><sizeX><sizeY> max.50 indexe
	;index buffer=start
	ldi	zh,high(bufINDEX)
	ldi	zl,low(bufINDEX)
    ldi yh,high(bufINDEXend)
    ldi yl,low(bufINDEXend)
	lds	xl,CURindex
_EQUindexLP:
	ld	xh,z
	cp	xl,xh			;soll=ist vergleich
	breq	_EQUindexLPok	;gleich & auf display darstellbar
	adiw	zh:zl,5
    cp  zl,yl
    cpc zh,yh
    brlo    _EQUindexLP
	jmp _CURSORbk

	;
_EQUindexLPok:
	adiw	zh:zl,1
	ld	xl,z+			;BOXposX holen
	sts	graphBOXposXte,xl	;x speichern
	sts	xPOSabs,xl
	sts	curBOXaktX,xl
	;
	ld	xl,z+
	sts	graphBOXposYte,xl	;y speichern
	sts	yPOSabs,xl
	sts	curBOXaktY,xl
	;
	ld	xl,z+
	sts	xCHARsiz,xl		;char x speichern
	sts	curSIZaktX,xl
	;
	ld	xl,z
	sts	yCHARsiz,xl		;char y speichern
	sts	curSIZaktY,xl
	;linienstrke cursorbox
	ldi	xl,1
	sts	LINEth,xl
	sts	curLINEakt,xl
	;graphische darstellung
	clr	xl
	sbr	xl,1<<graphBOXcont
;	sbr	xl,1<<graphBOXfull
;	sbr	xl,1<<graphBOXclr ;zum lschen setzen !!!
;	sbr	xl,1<<graphBOXinv   ;
	sts	graphBOXflTE,xl
	;nun cursorbox darstellen
	call	_DRWrectangle
	;nun curINIT setzen...
	lds	xl,curMODflTE
	sbr	xl,1<<curINIT	;initialisiert !!!
	sts	curMODflTE,xl
	;fertig & zurck
	jmp	_CURSORbk

	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~









;*****************************************************************
;zurck
_CURSORbk:
	ret



	
