;****************************************************************
;font-table
;****************************************************************
;a) text-mode:
;darstellbare ascii-codes:
;    space  = 0x20	
;	!	= 0x21				
;	"	= 0x22
;	#	= 0x23		
;	$	= 0x24
;	%	= 0x25
;	&	= 0x26
;	'	= 0x27
;	(	= 0x28
;	)	= 0x29	
;	*	= 0x2a		
;	+	= 0x2b		
;	,	= 0x2c
;	-	= 0x2d		
;	.	= 0x2e
;	/	= 0x2f
;
;	0	= 0x30  
;	1	= 0x31
;	2	= 0x32
;	3	= 0x33
;	4	= 0x34
;	5	= 0x35
;	6	= 0x36
;	7	= 0x37
; 	8	= 0x38
;	9	= 0x39
;
;	:	= 0x3a
;	;	= 0x3b
;	<	= 0x3c
;	=	= 0x3d
;	>	= 0x3e
;	?	= 0x3f
;	@	= 0x40
;	A	= 0x41	a	= 0x61		= 0x8e		= 0x84
;	B	= 0x42	b	= 0x62
;	C	= 0x43	c	= 0x63
;	D	= 0x44	d	= 0x64
;	E	= 0x45	e	= 0x65
;	F	= 0x46	f	= 0x66
;	G	= 0x47	g	= 0x67
;	H	= 0x48	h	= 0x68
;	I	= 0x49	i	= 0x69
;	J	= 0x4a	j	= 0x6a
;	K	= 0x4b	k	= 0x6b
;	L	= 0x4c	l	= 0x6c
;	M	= 0x4d	m	= 0x6d
;	N	= 0x4e	n	= 0x6e
;	O	= 0x4f	o	= 0x6f		= 0x99		= 0x94
;	P	= 0x50	p	= 0x70
;	Q	= 0x51	q	= 0x71
;	R	= 0x52	r	= 0x72
;	S	= 0x53	s	= 0x73
;	T	= 0x54	t	= 0x74
;	U	= 0x55	u	= 0x75		= 0x9a		= 0x81
;	V	= 0x56	v	= 0x76
;	W	= 0x57	w	= 0x77
;	X	= 0x58	x	= 0x78
;	Y	= 0x59	y	= 0x79
;	Z	= 0x5a	z	= 0x7a
;	
;	[	= 0x5b
;	\	= 0x5c
;	]	= 0x5d
;	^	= 0x5e
;	_	= 0x5f
;	`	= 0x60
;	{	= 0x7b
;	|	= 0x7c
;	}	= 0x7d
;	~	= 0x7e
;	<<	= 0xae
;	>>	= 0xaf
;
;
;

.cseg

			;format
			;y-line0	y-line1	     y-line2	y-line3      ....
			;________________________________________________....
	;x-page0|db0		|db0		|db0		|db0		|....		
	;		|___________|___________|___________|___________|....
	;		|db1		|db1		|db1		|db1		|....
	;		|___________|___________|___________|___________|....
	;		|db2		|db2		|db2		|db2		|....
	;		|___________|___________|___________|___________|....
	;		|db3		|db3		|db3		|db3		|....
	;		|___________|___________|___________|___________|....
	;		|db4		|db4		|db4		|db4		|....
	;		|___________|___________|___________|___________|....
	;		|db5		|db5		|db5		|db5		|....
	;		|___________|___________|___________|___________|....
	;		|db6		|db6		|db6		|db6		|....
	;		|___________|___________|___________|___________|....
	;		|db7		|db7		|db7		|db7		|....
	;		|___________|___________|___________|___________|....
	;x-page1|db0		|db0		|db0		|db0		|....		
	;		|___________|___________|___________|___________|....
	;		|db1		|db1		|db1		|db1		|....
	;		|___________|___________|___________|___________|....
	;		|db2		|db2		|db2		|db2		|....
	;		|___________|___________|___________|___________|....
	;		|db3		|db3		|db3		|db3		|....
	;		|___________|___________|___________|___________|....
	;		|db4		|db4		|db4		|db4		|....
	;		|___________|___________|___________|___________|....
	;		|db5		|db5		|db5		|db5		|....
	;		|___________|___________|___________|___________|....
	;		|db6		|db6		|db6		|db6		|....
	;		|___________|___________|___________|___________|....
	;		|db7		|db7		|db7		|db7		|....
	;		|___________|___________|___________|___________|....
	;
	;			
	
font0x20_lines:
		.db	0,0,0,0,0,0					;space 
		
font0x21_lines:
		.db	0,0,0x4f,0,0,0				; !

font0x22_lines:
		.db	0,0x7,0,0x7,0,0				; "

font0x23_lines:
		.db	0x14,0x7f,0x14,0x7f,0x14,0		; #

font0x24_lines:
		.db	0x24,0x2a,0x7f,0x2a,0x12,0		; $

font0x25_lines:
		.db	0x23,0x13,0x8,0x64,0x62,0		; %

font0x26_lines:
		.db	0x36,0x49,0x55,0x22,0x50,0		; &

font0x27_lines:
		.db	0,0,0x7,0,0,0				; '

font0x28_lines:
		.db	0,0,0x1c,0x22,0x41,0			; (

font0x29_lines:
		.db	0,0,0x41,0x22,0x1c,0			; )

font0x2a_lines:
		.db	0x14,0x8,0x3e,0x8,0x14,0		; *

font0x2b_lines:
		.db	0x8,0x8,0x3e,0x8,0x8,0			; +

font0x2c_lines:
		.db	0,0x50,0x30,0,0,0				; ,

font0x2d_lines:
		.db	0x8,0x8,0x8,0x8,0x8,0			; -

font0x2e_lines:
		.db	0,0x60,0x60,0,0,0				; .

font0x2f_lines:
		.db	0x20,0x10,0x8,0x4,0x2,0			; /

font0x30_lines:
		.db	0x3e,0x51,0x49,0x45,0x3e,0		; 0

font0x31_lines:
		.db	0,0x42,0x7f,0x40,0,0			; 1

font0x32_lines:
		.db	0x42,0x61,0x51,0x49,0x46,0		; 2

font0x33_lines:
		.db	0x21,0x41,0x45,0x4b,0x31,0		; 3

font0x34_lines:
		.db	0xc,0xa,0x9,0x7f,0x8,0			; 4

font0x35_lines:
		.db	0x27,0x45,0x45,0x45,0x39,0		; 5

font0x36_lines:
		.db	0x3c,0x4a,0x49,0x49,0x30,0		; 6

font0x37_lines:
		.db	0x2,0x1,0x71,0x9,0x7,0			; 7

font0x38_lines:
		.db	0x36,0x49,0x49,0x49,0x36,0		; 8

font0x39_lines:
		.db	0x6,0x49,0x49,0x29,0x1e,0		; 9

font0x3a_lines:
		.db	0,0x36,0x36,0,0,0				; :

font0x3b_lines:
		.db	0,0x56,0x36,0,0,0				; ;

font0x3c_lines:
		.db	0,0x8,0x14,0x22,0x41,0			; <

font0x3d_lines:
		.db	0x14,0x14,0x14,0x14,0x14,0		; =

font0x3e_lines:
		.db	0,0x41,0x22,0x14,0x8,0			; >

font0x3f_lines:
		.db	0x2,0x1,0x51,0x9,0x6,0			; ?

font0x40_lines:
		.db	0x32,0x49,0x59,0x41,0x3e,0		; @

font0x41_lines:
		.db	0x7e,0x9,0x9,0x9,0x7e,0			; A

font0x42_lines:
		.db	0x7f,0x49,0x49,0x49,0x3e,0		; B

font0x43_lines:
		.db	0x3e,0x41,0x41,0x41,0x22,0		; C

font0x44_lines:
		.db	0x7f,0x41,0x41,0x22,0x1c,0		; D

font0x45_lines:
		.db	0x7f,0x49,0x49,0x49,0x41,0		; E

font0x46_lines:
		.db	0x7f,0x9,0x9,0x1,0x1,0			; F

font0x47_lines:
		.db	0x3e,0x41,0x49,0x49,0x7a,0		; G

font0x48_lines:
		.db	0x7f,0x8,0x8,0x8,0x7f,0			; H

font0x49_lines:
		.db	0,0x41,0x7f,0x41,0,0			; I

font0x4a_lines:
		.db	0x20,0x40,0x41,0x3f,0x1,0		; J

font0x4b_lines:
		.db	0x7f,0x8,0x14,0x22,0x41,0		; K

font0x4c_lines:
		.db	0x7f,0x40,0x40,0x40,0x40,0		; L

font0x4d_lines:
		.db	0x7f,0x2,0xc,0x2,0x7f,0			; M

font0x4e_lines:
		.db	0x7f,0x4,0x8,0x10,0x7f,0		; N

font0x4f_lines:
		.db	0x3e,0x41,0x41,0x41,0x3e,0		; O

font0x50_lines:
		.db	0x7f,0x9,0x9,0x9,0x6,0			; P

font0x51_lines:
		.db	0x3e,0x41,0x51,0x21,0x5e,0		; Q

font0x52_lines:
		.db	0x7e,0x9,0x19,0x29,0x46,0		; R

font0x53_lines:
		.db	0x46,0x49,0x49,0x49,0x31,0		; S

font0x54_lines:
		.db	0x1,0x1,0x7f,0x1,0x1,0			; T

font0x55_lines:
		.db	0x3f,0x40,0x40,0x40,0x3f,0		; U

font0x56_lines:
		.db	0x1f,0x20,0x40,0x20,0x1f,0		; V

font0x57_lines:
		.db	0x3f,0x40,0x38,0x40,0x3f,0		; W

font0x58_lines:
		.db	0x63,0x14,0x8,0x14,0x63,0		; X

font0x59_lines:
		.db	0x7,0x8,0x70,0x8,0x7,0			; Y

font0x5a_lines:
		.db	0x61,0x51,0x49,0x45,0x43,0		; Z

font0x5b_lines:
		.db	0x7f,0x41,0x41,0,0,0			; [

font0x5c_lines:
		.db	0x2,0x4,0x8,0x10,0x20,0			; \

font0x5d_lines:
		.db	0,0,0x41,0x41,0x7f,0			; ]

font0x5e_lines:
		.db	0x4,0x2,0x1,0x2,0x4,0			; ^

font0x5f_lines:
		.db	0x40,0x40,0x40,0x40,0x40,0		; _

font0x60_lines:
		.db	0,0,0x1,0x2,0x4,0				; `

font0x61_lines:
		.db	0x20,0x54,0x54,0x54,0x78,0		; a

font0x62_lines:
		.db	0x7f,0x48,0x44,0x44,0x38,0		; b

font0x63_lines:
		.db	0x38,0x44,0x44,0x44,0x20,0		; c

font0x64_lines:
		.db	0x38,0x44,0x44,0x48,0x7f,0		; d

font0x65_lines:
		.db	0x38,0x54,0x54,0x54,0x8,0		; e

font0x66_lines:
		.db	0x8,0x7e,0x9,0x1,0x2,0			; f

font0x67_lines:
		.db	0x18,0xa4,0xa4,0xa4,0x7c,0		; g

font0x68_lines:
		.db	0x7f,0x8,0x4,0x4,0x78,0			; h

font0x69_lines:
		.db	0,0x44,0x7d,0x40,0,0			; i

font0x6a_lines:
		.db	0,0x40,0x80,0x84,0x7d,0			; j

font0x6b_lines:
		.db	0x7f,0x10,0x28,0x44,0,0			; k

font0x6c_lines:
		.db	0,0x41,0x7f,0x40,0,0			; l

font0x6d_lines:
		.db	0x7c,0x4,0x18,0x4,0x78,0		; m

font0x6e_lines:
		.db	0x7c,0x8,0x4,0x4,0x78,0			; n

font0x6f_lines:
		.db	0x38,0x44,0x44,0x44,0x38,0		; o

font0x70_lines:
		.db	0xfc,0x48,0x44,0x44,0x38,0		; p

font0x71_lines:
		.db	0x38,0x44,0x44,0x48,0xfc,0		; q

font0x72_lines:
		.db	0x7c,0x8,0x4,0x4,0x8,0			; r

font0x73_lines:
		.db	0x48,0x54,0x54,0x54,0x20,0		; s

font0x74_lines:
		.db	0x4,0x3f,0x44,0x40,0x20,0		; t

font0x75_lines:
		.db	0x3c,0x40,0x40,0x20,0x7c,0		; u

font0x76_lines:
		.db	0x1c,0x20,0x40,0x20,0x1c,0		; v

font0x77_lines:
		.db	0x3c,0x40,0x38,0x40,0x3c,0		; w

font0x78_lines:
		.db	0x44,0x28,0x10,0x28,0x44,0		; x

font0x79_lines:
		.db	0xc,0x50,0x50,0x50,0x3c,0		; y

font0x7a_lines:
		.db	0x44,0x64,0x54,0x4c,0x44,0		; z

font0x7b_lines:
		.db	0x8,0x36,0x41,0,0,0			; {

font0x7c_lines:
		.db	0,0,0x7f,0,0,0				; |

font0x7d_lines:
		.db	0,0,0x41,0x36,0x8,0			; }

font0x7e_lines:
		.db	0xc,0x2,0x4,0x8,0x6,0			; ~

font0x7f_lines:
		.db	0,0,0,0,0,0					; DEL - no bmp

font0x80_lines:
		.db	0,0,0,0,0,0					; C` - no bmp

font0x81_lines:
		.db	0x3c,0x41,0x40,0x21,0x7c,0		;

font0x82_lines:
		.db	0,0,0,0,0,0					; no bmp

font0x83_lines:
		.db	0,0,0,0,0,0					; no bmp

font0x84_lines:
		.db	0x20,0x55,0x54,0x55,0x78,0		; 

font0x85_lines:
		.db	0,0,0,0,0,0					; no bmp

font0x86_lines:
		.db	0,0,0,0,0,0					; no bmp

font0x87_lines:
		.db	0,0,0,0,0,0					; no bmp

font0x88_lines:
		.db	0,0,0,0,0,0					; no bmp

font0x89_lines:
		.db	0,0,0,0,0,0					; no bmp

font0x8a_lines:
		.db	0,0,0,0,0,0					; no bmp

font0x8b_lines:
		.db	0,0,0,0,0,0					; no bmp

font0x8c_lines:
		.db	0,0,0,0,0,0					; no bmp

font0x8d_lines:
		.db	0,0,0,0,0,0					; no bmp

font0x8e_lines:
		.db	0x7c,0x15,0x14,0x15,0xfc,0		; 

font0x8f_lines:
		.db	0,0,0,0,0,0					; no bmp

font0x90_lines:
		.db	0,0,0,0,0,0					; no bmp

font0x91_lines:
		.db	0,0,0,0,0,0					; no bmp

font0x92_lines:
		.db	0,0,0,0,0,0					; no bmp

font0x93_lines:
		.db	0,0,0,0,0,0					; no bmp

font0x94_lines:
		.db	0x38,0x45,0x44,0x45,0x38,0		; 



.exit







